/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 4.0.2
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */
package com.herumi.mcl

import kotlin.jvm.JvmOverloads
import com.herumi.mcl.MclJNI
import kotlin.jvm.Synchronized
import com.herumi.mcl.Fp
import com.herumi.mcl.Fr
import com.herumi.mcl.G1
import com.herumi.mcl.G2
import com.herumi.mcl.GT
import com.herumi.mcl.MclConstants
import com.herumi.mcl.SWIGTYPE_p_bool
import com.herumi.mcl.ElgamalJNI
import com.herumi.mcl.CipherText

class CipherText protected constructor(
    @field:Transient private var swigCPtr: Long,
    @field:Transient protected var swigCMemOwn: Boolean
) {
    protected fun finalize() {
        delete()
    }

    @Synchronized
    fun delete() {
        if (swigCPtr != 0L) {
            if (swigCMemOwn) {
                swigCMemOwn = false
                ElgamalJNI.delete_CipherText(swigCPtr)
            }
            swigCPtr = 0
        }
    }

    fun toStr(): String? {
        return ElgamalJNI.CipherText_toStr(swigCPtr, this)
    }

    override fun toString(): String {
        return ElgamalJNI.CipherText_toString(swigCPtr, this)!!
    }

    fun fromStr(str: String?) {
        ElgamalJNI.CipherText_fromStr(swigCPtr, this, str)
    }

    fun add(c: CipherText?) {
        ElgamalJNI.CipherText_add(swigCPtr, this, getCPtr(c), c)
    }

    fun mul(m: Int) {
        ElgamalJNI.CipherText_mul__SWIG_0(swigCPtr, this, m)
    }

    fun mul(str: String?) {
        ElgamalJNI.CipherText_mul__SWIG_1(swigCPtr, this, str)
    }

    constructor() : this(ElgamalJNI.new_CipherText(), true) {}

    companion object {
        fun getCPtr(obj: CipherText?): Long {
            return obj?.swigCPtr ?: 0
        }
    }
}